<?php

/** Field Permissions (v1.0)
 * 2019-11-05
 * Olaf Nöhring
 * https://datenbank-projekt.de
 * 
 * This file contains functions to check for field permissions and react on unexpected values.
 * 
 * NOTE: YOU NEED TO USE AppGini Helper which can be obtained for small money from https://www.bizzworxx.de/en/appgini-helper/
 * 		 I DECIDED TO USE AppGini Helper AS IT IS A GREAT SCRIPT WHICH SUPPORTS ALL FIELD TYPES OF APPGINI.
 * 		 PLEASE TAKE A LOOK AND SUPPORT jsetzer WHO IS THE PROGRAMMER AND GREAT SUPPORTER OF ALL USERS IN THE APPGINI FORUM.
 */

//Um Logdatei zu schreiben	
/*
if (!function_exists('write_log')) {
	include("hooks/write_log.php");
}
*/


/**
 * Function checks if user has limited permissions
 * @ $tablename What tablename needs to be checked
 * @ $memberID  For which user
 * @ $state     What should be checked? is_hidden | is_locked
 */

function check_field_permission($tablenam, $memberID, $state)
{
	$divider = '*';
	$list_fields = "";

	$groupID = getLoggedGroupID();

	//write_log("table: $tablenam, member: $memberID, group: $groupID, state: $state");

	$sql = "SELECT * FROM db_field_permission WHERE table_field LIKE '" . $tablenam . $divider . "%' AND fieldstate = '" . $state . "' AND groupID = " . $groupID . ";";
	//write_log("SQL: $sql");

	$arr_table_field = array();
	$result = sql($sql, $eo);
	while ($row = db_fetch_assoc($result)) {
		$arr_table_field[] = str_replace($tablenam . $divider, "", $row['table_field']);
	}
	$list_fields = implode(",", $arr_table_field);
	//write_log("list_fields ($state): $list_fields");

	return $list_fields;
}

/**
 * Function padds CSV list with additional characters
 * @ $field_list  CSV list
 * @ $additionalPadding Character to be used for padding
 */

function pad_field_permissions($field_list, $additionalPadding)
{
	$padded_field_list = "";
	$field_list = str_replace(',', $additionalPadding . ',' . $additionalPadding, $field_list);
	$field_list = $additionalPadding . $field_list . $additionalPadding;
	$padded_field_list = $field_list;
	//write_log("padded_field_list: $padded_field_list");
	return $padded_field_list;
}

/**
 * Lock record in use
 * future plan: make it possible to prevent editing when another user has requested this record
 * things to watch for: 
 * 		when did the other user request the same record (time)
 * 		once a user has clicked the save button the lock is removed again
 */

function record_is_locked_field_permissions($currentID)
{ }

/**
 * Function tests if current value (before saving) is still the same as old value in database 
 * 	for the fields that are either set to locked or set to hidden
 * @ $data	Array comming from AppGini
 * @ $memberInfo	Array comming from AppGini
 * @ $field_permission_tablenam		Name of the table the users tries to change a record in
 * @ $field_permission_tableID		Name of the primarykey field in the table the users tries to change a record in
 */

function check_BE_field_permissions($data, $memberInfo, $field_permission_tablenam, $field_permission_tableID)
{

	$myReturnValue = TRUE;								//set default value

	$clean_selectedID = makeSafe($data['selectedID']);	// which record are we testing?

	$fields_is_locked = "";
	$fields_is_hidden = "";
	$fields_is_locked = check_field_permission($field_permission_tablenam, getLoggedMemberID(), "locked");
	$fields_is_hidden = check_field_permission($field_permission_tablenam, getLoggedMemberID(), "hidden");

	$fields_locked = explode(",", $fields_is_locked);
	$fields_hidden = explode(",", $fields_is_hidden);
	$fields_is_special_permission = array_merge($fields_locked, $fields_hidden);

	$sql_fieldlist = implode(",", $fields_is_special_permission);

	if ($sql_fieldlist <> ","){		// if at least one field in this table has a special permission - otherwiese: all ok and continue
		#write_log("implode: ".$sql_fieldlist);
		$sql_padded_fieldlist = pad_field_permissions($sql_fieldlist, '`');

		$sql = "SELECT $sql_padded_fieldlist FROM `$field_permission_tablenam` WHERE $field_permission_tableID = " . $clean_selectedID;
		#write_log("sql all fields: ".$sql);

		$result_fieldlist = sql($sql, $eo);
		$row_result_fieldlist = db_fetch_assoc($result_fieldlist);

		$fields_cheating = array();		// fields in which unexpected values occur
		foreach ($fields_is_special_permission as $key => $value) {
			#	write_log("ar2: ".$value);			
			$clean_data_fieldvalue_new = makeSafe($data[$value]);
			$result = $row_result_fieldlist[$value];
			#	write_log("ar2 clean_data_fieldvalue_new: ".$clean_data_fieldvalue_new);			
			#	write_log("ar2 result: ".$result);	

			if ($result !== $clean_data_fieldvalue_new) {
				$fields_cheating[] = $value;
			}
		}
		#write_log("count fields_cheating: ". count($fields_cheating));

		if (count($fields_cheating) <> 0) {
			//this session variable is some extra: If you want to use custom errors, please check my solution here https://forums.appgini.com/phpbb/viewtopic.php?f=7&t=1740&p=10906#p10906
			$_SESSION['custom_err_msg'] = 'Edits rejected due to assumed cheating. The record can not be saved. Problems at: ' . implode(", ", $fields_cheating) . '';

			$myReturnValue = FALSE;		// some unexpected values, so we deny adding/updating this record
		}
	}	

	return $myReturnValue;
}
?>